module CONTROLLER (CLK, NEW_KEY, ENABLE, X_COORD, Y_COORD, SCAN_CODE, value, RGB_VAL, lookup) ;
input CLK;
input NEW_KEY, ENABLE;
input [3:0] value;
input [9:0] X_COORD, Y_COORD;
input [7:0] SCAN_CODE;
output [2:0] RGB_VAL;
output [12:0] lookup;
reg [2:0] RGB_VAL;
reg [9:0] X_VAL_LOW, X_VAL_HIGH, Y_VAL_LOW, Y_VAL_HIGH, X_VAL_LINE, Y_VAL_LINE, X_LINE1, Y_LINE1;
reg [7:0] COUNTER;
reg [9:0] COUNTER2;
reg NEW_KEY_HOLD, Lvalid;
reg [9:0] RAND_SEED;
reg [31:0] COUNTER3;
reg [9:0] rel_x;
reg [9:0] rel_y;
reg [12:0] lookup;

always @(posedge CLK) begin

	// reset step
	if(SCAN_CODE == 'h76) begin
		X_VAL_LOW <= 300;
		X_VAL_HIGH <= 316;
		Y_VAL_LOW <= 250;
		Y_VAL_HIGH <= 283;
		X_VAL_LINE <= 310;
		Y_VAL_LINE <= 0;
		X_LINE1 <= 310;
		Y_LINE1 <= 240;
		COUNTER <= 0;
		COUNTER2 <= 0;
		NEW_KEY_HOLD <= 0;
		RAND_SEED <= 0;
		COUNTER3 <= 0;
	end
	// prepare to check keys
		
	if(ENABLE) begin		// if the logical and of HRGB and VRGB is 1, do something
		// increment counters
		if(COUNTER3 == 0) begin
			RAND_SEED <= X_COORD;
		end
		COUNTER3 <= COUNTER3 + 1;
		COUNTER <= COUNTER + 1;		
		if(COUNTER == 0) begin
			COUNTER2 <= COUNTER2 + 1;
		end
		
		// check to see if we have a new key
		if(NEW_KEY_HOLD == 0) begin
			NEW_KEY_HOLD <= NEW_KEY;
		end
		
		// if we have a new key, go to work, process input
		else begin
			if(COUNTER == 0)begin
				NEW_KEY_HOLD <= 0;
				case (SCAN_CODE)
				'h75: begin		// up arrow
					if(Y_VAL_LOW == 160) begin
						Y_VAL_LOW <= 160;
					end
					else begin
						Y_VAL_LOW <= Y_VAL_LOW - 1;
					end
					if(Y_VAL_HIGH == 193) begin
						Y_VAL_HIGH <= 193;
					end
					else begin
						Y_VAL_HIGH <= Y_VAL_HIGH - 1;
					end 
				end
				'h72: begin		// down arrow
					if(Y_VAL_LOW == 447) begin
						Y_VAL_LOW <= 447;
					end
					else begin
						Y_VAL_LOW <= Y_VAL_LOW + 1;
					end
					if(Y_VAL_HIGH == 480) begin
						Y_VAL_HIGH <= 480;
					end
					else begin
						Y_VAL_HIGH <= Y_VAL_HIGH + 1;
					end 
				end
				'h6b: begin		// left arrow
					if(X_VAL_LOW == 150) begin
						X_VAL_LOW <= 150;
					end
					else begin
						X_VAL_LOW <= X_VAL_LOW - 1;
					end
					if(X_VAL_HIGH == 166) begin
						X_VAL_HIGH <= 166;
					end
					else begin
						X_VAL_HIGH <= X_VAL_HIGH - 1;
					end 
				end
				'h74: begin		// right arrow
					if(X_VAL_LOW == 474) begin
						X_VAL_LOW <= 474;
					end
					else begin
						X_VAL_LOW <= X_VAL_LOW + 1;
					end
					if(X_VAL_HIGH == 490) begin
						X_VAL_HIGH <= 490;
					end
					else begin
						X_VAL_HIGH <= X_VAL_HIGH + 1;
					end 
				end
				'h76: begin		// escape key - return to default settings
					X_VAL_LOW <= 300;
					X_VAL_HIGH <= 316;
					Y_VAL_LOW <= 250;
					Y_VAL_HIGH <= 282;
					X_VAL_LINE <= 310;
					Y_VAL_LINE <= 0;
					X_LINE1 <= 310;
					Y_LINE1 <= 240;
					RAND_SEED <= 0;
				end
				'h29: begin		// space bar
				end
				default: begin		// any other key
				end
				endcase
			end // end if counter == 0
		end // end else new key
		
		// general layout
		if(X_COORD < 150 || X_COORD > 490) begin	// grass
			RGB_VAL <= 'b010;
		end 
		
		// roadway
		else begin
		if(X_COORD < X_VAL_HIGH && X_COORD >= X_VAL_LOW && Y_COORD >= Y_VAL_LOW && Y_COORD <= Y_VAL_HIGH) begin		
			if(rel_x-1 < 0) begin
				rel_y <= Y_COORD - Y_VAL_LOW;
			end
			else begin
			rel_y <= Y_COORD - Y_VAL_LOW-1;
			end
			rel_x <= X_COORD - X_VAL_LOW+1;
			Lvalid <= 1;
			lookup[12:11] <= 'b00;
			lookup[6:3] <= rel_y[3:0];
			lookup[2:0] <= rel_x[2:0];
			lookup[8:7] <= rel_x[4:3];
			lookup[10:9] <= rel_y[5:4];
		end
		else begin
			Lvalid <= 0;
			lookup <= 0;
		end
		// draw the vehicle
		//also check for transparency		
		if(X_COORD <= X_VAL_HIGH && X_COORD > X_VAL_LOW && Y_COORD > Y_VAL_LOW && Y_COORD < Y_VAL_HIGH && Lvalid && (value[3:3] == 1)) begin
				RGB_VAL <= value[2:0];
			//RGB_VAL <= 'b100;
		end
		else begin
		// draw and update position for the centerline
		if(X_COORD > 315 && X_COORD < 325 ) begin
			if(COUNTER2 == 0) begin
				if(Y_VAL_LINE > 479) begin
					Y_VAL_LINE <= 0;
				end
				else begin
					Y_VAL_LINE <= Y_VAL_LINE + 1;
				end
				if(Y_LINE1 > 479) begin
					Y_LINE1 <= 0;
				end
				else begin
					Y_LINE1 <= Y_LINE1 + 1;
				end
			end // end counter2 == 0
			
			// check first middle stripe
			if((Y_COORD > Y_VAL_LINE) && (Y_COORD < (Y_VAL_LINE + 50))) begin
					RGB_VAL <= 'b111;
			end // end y_COORD....
			
			// check second middle stripe
			else begin
			if((Y_COORD > Y_LINE1) && (Y_COORD < (Y_LINE1 + 50))) begin
					RGB_VAL <= 'b111;

			end // end y_COORD....
			
			else begin
				RGB_VAL <= 'b0;
			end
			end // else not first stripe
		end // end X_Coord ...
		else begin
			RGB_VAL <= 'b0;
		end // end else not centerline
		end // end else not vehicle
		end // end roadway else

	end // enable
	//else begin			// otherwise, do nothing
	//	RGB_VAL <= 0;
	//end	
end // end always block

endmodule 
