module rgbcalc(clk, x, y, ballx, bally, bricks, paddlex, r, g, b);

input clk;
input [9:0] x, y;
input [9:0] ballx;
input [8:0] bally;
input [59:0] bricks;
input [9:0] paddlex;
output r, g, b;

wire inpaddle, inball;
wire rb,ra,gb,ga,bb,ba;
wire r, g, b;
wire [6:0] bnum;
wire [5:0] bricknum;
wire bvalid;

assign inpaddle = (y >= 460 && y <= 465 && x >= paddlex - 20 && x <= paddlex + 20);
assign inball = (x >= ballx - 2 && x <= ballx + 2 && y >= bally - 2 && y <= bally + 2); 
assign bnum = 10 * y[8:5] + x[9:6] - 29;
assign bricknum = (bnum > 60 || bnum == 0) ? 0 : bnum;
assign bvalid = (bricknum == 0) ? 0 : bricks[bricknum-1];

assign rb = (bvalid && (bricknum >= 1 && bricknum <= 20) || (bricknum >= 51 && bricknum <= 60)) ? 1 : 0;
assign ra = (inpaddle) ? 1 : rb;
assign r = (inball) ? 1 : ra;

assign gb = (bvalid && bricknum >= 11 && bricknum <= 40) ? 1 : 0;
assign ga = (inpaddle) ? 1 : gb;
assign g = (inball) ? 0 : ga;

assign bb = (bvalid && bricknum >= 31 && bricknum <= 60) ? 1 : 0;
assign ba = (inpaddle) ? 1 : bb;
assign b = (inball) ? 0 : ba;

endmodule
