module StackCounter (clk, clk_en, up_dn, reset, cout);

input clk, clk_en, up_dn, reset;
output [3:0] cout;
wire [3:0] cout;

reg [3:0] counter;

assign cout = counter;

// need to put the clear instruction at the beginning to clear the stack and the counter
always @ (posedge clk) begin
  if (reset) counter <= 0;
  else begin
    if (clk_en) begin
      if (up_dn) counter <= counter + 1;
      else counter <= counter - 1;
    end
  end
end

endmodule
