------------------------------------------------------
-- LogiBLOX ADD_SUB Module "y_val"
-- Created by LogiBLOX version D.24
--    on Tue Feb 27 18:04:41 2001
-- Attributes 
--    MODTYPE = ADD_SUB
--    BUS_WIDTH = 10
--    OPTYPE = SUB
--    REGISTERED = NONE
--    ENCODING = UNSIGNED
--    STYLE = MIN_AREA
--    C_VALUE = 35
------------------------------------------------------
-- This is a behaviorial model only and cannot be synthesized.
------------------------------------------------------
LIBRARY IEEE;
USE IEEE.std_logic_1164.ALL;

-- synopsys translate_off
LIBRARY logiblox;
USE logiblox.mvlutil.ALL;
USE logiblox.mvlarith.ALL;
USE logiblox.logiblox.ALL;
-- synopsys translate_on

ENTITY y_val IS
  PORT(
    A: IN std_logic_vector(9 DOWNTO 0);
    SUM: OUT std_logic_vector(9 DOWNTO 0));
END y_val;

-- synopsys translate_off
ARCHITECTURE sim OF y_val IS
    SIGNAL START_PULSE: std_logic := '1';
BEGIN
  PROCESS
    VARIABLE VADD_SUB: std_logic;
    VARIABLE VC_IN: std_logic;
    VARIABLE VA: std_logic_vector(9 DOWNTO 0);
    VARIABLE VB: std_logic_vector(9 DOWNTO 0);
    VARIABLE VLOAD: std_logic;
    VARIABLE VCLK_EN: std_logic;
    VARIABLE VCLOCK: std_logic;
    VARIABLE VASYNC_CTRL: std_logic;
    VARIABLE VSYNC_CTRL: std_logic;
    VARIABLE VSUM: std_logic_vector(9 DOWNTO 0);
    VARIABLE VOVFL: std_logic;
    VARIABLE VC_OUT: std_logic;
    BEGIN
      VADD_SUB := '1';
      VA := stdvec2mvl(A);
      VLOAD := '0';
      VASYNC_CTRL := '0';
      VSYNC_CTRL := '0';
      VADD_SUB := '0';
      VC_IN := NOT (VADD_SUB);
      VB := ('0','0','0','0','1','0','0','0','1','1');
      xb_accum(
               START_PULSE,
               VA,
               VB,
               VC_IN,
               VADD_SUB,
               VLOAD,
               VASYNC_CTRL,
               ('0','0','0','0','0','0','0','0','0','0'),
               '0',
               '0',
               VSYNC_CTRL,
               ('0','0','0','0','0','0','0','0','0','0'),
               '0',
               '0',
               UNSIGNED,
               NONE,
               VSUM,
               VC_OUT,
               VOVFL);
      SUM <= VSUM;
      IF (START_PULSE='1') THEN
        START_PULSE <= '0' AFTER 1 ns;
      END IF;
      WAIT ON A, START_PULSE;
  END PROCESS;
END sim;
-- synopsys translate_on
